{% extends 'base.html.twig' %}

{% set section='pantries'|trans %}

{% block body %}
    <div class="container-fluid mt-2">


        <div class="mt-2">
            {% include '_pugx_filter_b5.html.twig' with {name: 'product_presence'} %}
            {% from '_pugx_sort_b5.html.twig' import sort -%}
        </div>
        <table class="table table-striped">
            <thead>
            <tr>
                <th scope="col"></th>
                <th scope="col">
                    {% trans %}Product{% endtrans %} {{ sort('product_presence_sort', 'product_presence', 'product') }}
                </th>
                <th scope="col">
                    {% trans %}Expiration{% endtrans %} {{ sort('product_presence_sort', 'product_presence', 'expiration') }}
                    <br>
                    {% trans %}Quantity{% endtrans %} {{ sort('product_presence_sort', 'product_presence', 'quantity') }}
                    <br>
                    {% trans %}Pantry{% endtrans %} {{ sort('product_presence_sort', 'product_presence', 'pantry') }}
                </th>
            </tr>
            </thead>
            <tbody>
            {% for productPresence in entities %}
                <tr>
                    <td>
                        <a href="#removeModal" data-id="{{ productPresence.id }}"
                           data-quantity="{{ productPresence.quantity }}"
                           data-product-name="{{ productPresence.product }}"
                           data-bs-toggle="modal" data-bs-target="#removeModal"
                           class="remove-products btn btn-primary">
                            <i class="bi bi-box-arrow-in-left"></i>
                        </a>

                        <a href="#moveModal" data-id="{{ productPresence.id }}"
                           data-quantity="{{ productPresence.quantity }}"
                           data-product-name="{{ productPresence.product }}"
                           data-bs-toggle="modal" data-bs-target="#moveModal"
                           class="move-products btn btn-info">
                            <i class="bi bi-repeat"></i>
                        </a>
                        {% if productPresence.product is not null and productPresence.product.barcode is defined %}
                            <a href="https://world.openfoodfacts.org/cgi/product.pl?type=edit&code={{ productPresence.product.barcode }}"
                               class="btn btn-outline-info" target="_blank">
                                <i class="bi bi-pencil"></i>
                            </a>
                        {% endif %}
                    </td>
                    <td>
                        {% if productPresence.product.brand.name is defined %}
                            <a data-bs-toggle="tooltip"
                               title="" data-bs-original-title="{{ productPresence.product.brand.name }}">
                            <i class="bi bi-info"></i></a>
                        {% endif %}




                        {{ productPresence.product.name }}
                    </td>
                    <td>
                        {{ productPresence.expiration|date('d/m/Y') }}<br>
                        {{ productPresence.quantity }}<br>
                        <div style="margin: 2px;padding: 2px;border-radius: 0px 10px 0px 10px; border-style: solid; border-color: {{ productPresence.pantry.house.color }};outline-offset: 4px;">
                        <span style="color:{{ productPresence.pantry.color }}">&#9632;</span>

                        {{ productPresence.pantry.name }}
                            </div>
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>

        <div class="d-grid gap-2">
                <a href="{{ path('product_presence_new') }}" class="btn btn-primary">
                    {% trans %}Add products{% endtrans %}
                </a>
        </div>

    </div>

    <!-- Modal -->
    <div class="modal" id="removeModal" tabindex="-1" aria-labelledby="removeModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="removeModalLabel">{% trans %}Remove product{% endtrans %}</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <label for="removeQuantity" class="form-label">
                        {% trans %}How many <span id="productName"></span> do you want to remove?{% endtrans %}
                    </label>
                    <input type="number" min="1" max="1" id="removeQuantity" class="form-control">
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
                        {% trans %}Close{% endtrans %}
                    </button>
                    <button type="button" class="btn btn-primary" id="removeButton">
                        {% trans %}Remove products{% endtrans %}
                    </button>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div class="modal" id="moveModal" tabindex="-1" aria-labelledby="moveModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="moveModalLabel">{% trans %}Move product{% endtrans %}</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <label for="moveQuantity" class="form-label">
                        {% trans %}How many <span id="productNameToMove"></span> do you want to move?{% endtrans %}
                    </label>
                    <input type="number" min="1" max="1" id="moveQuantity" class="form-control">
                    <label for="pantryToUse" class="form-label">
                        {% trans %}Where do you want to move?{% endtrans %}
                    </label>
                    <select id="pantryToUse" class="form-select">
                        {% for pantry in pantries %}
                            <option value="{{ pantry.id }}">{{ pantry.name }}</option>
                        {% endfor %}
                    </select>


                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
                        {% trans %}Close{% endtrans %}
                    </button>
                    <button type="button" class="btn btn-primary" id="moveButton">
                        {% trans %}Move products{% endtrans %}
                    </button>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

{% block javascripts %}
    {{ parent() }}
    <script>
        var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
        var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
            return new bootstrap.Tooltip(tooltipTriggerEl)
        })
        $('.remove-products').click(function () {
            var productPresenceId = $(this).attr('data-id')
            var maxQuantity = $(this).attr('data-quantity')
            var productName = $(this).attr('data-product-name')
            $('#productName').html(productName);
            $('#removeQuantity').val(maxQuantity);
            $('#removeQuantity').attr('max', maxQuantity);
            $('#removeQuantity').attr('data-id', productPresenceId);
        })
        $('#removeButton').click(function () {
            var url = "{{ path('product_presence_remove',{
                'productPresenceId':'__productPresenceId__',
                'quantity':'__quantity__' }) }}";
            url = url.replace('__productPresenceId__', $('#removeQuantity').attr('data-id'))
            url = url.replace('__quantity__', $('#removeQuantity').val())
            document.location = url;
        })


        $('.move-products').click(function () {
            var productPresenceId = $(this).attr('data-id')
            var maxQuantity = $(this).attr('data-quantity')
            var productName = $(this).attr('data-product-name')
            $('#productNameToMove').html(productName);
            $('#moveQuantity').val(maxQuantity);
            $('#moveQuantity').attr('max', maxQuantity);
            $('#moveQuantity').attr('data-id', productPresenceId);
        })
        $('#moveButton').click(function () {
            var url = "{{ path('product_presence_move',{
                'productPresenceId':'__productPresenceId__',
                'quantity':'__quantity__',
                'pantryId':'__pantry__', }) }}";
            url = url.replace('__productPresenceId__', $('#moveQuantity').attr('data-id'))
            url = url.replace('__quantity__', $('#moveQuantity').val())
            url = url.replace('__pantry__', $('#pantryToUse').val())
            document.location = url;
        })
    </script>
{% endblock %}